/********************************  
* lcd_xc8.h y XC8       	*
* www.firtec.com.ar             *																					*
*        			*
*********************************/

#include <p18cxxx.h>
#ifndef lcd_xc8_h
#define lcd_xc8_h

#define FCY 20000000UL	// Cristal del sistema
#define _delay_100us() Delay100TCYx(FCY/4000000UL)
#define _delay_5ms() Delay1KTCYx(FCY/800000UL)

// Funciones contenidas en el driver.
void lcd_puts(char *ptr);
void lcd_putrs(const char *ptr);
void lcd_setcursor_vb(unsigned char, unsigned char);
void lcd_comand(unsigned char);
void lcd_putc(unsigned char);
void lcd_gotoxy(unsigned char, unsigned char);
void lcd_init(void);
void lcd_send_byte(unsigned char, unsigned char);
void lcd_send_nibble(unsigned char);

//------ Pines donde se conecta la pantalla ---------
//#define USE_RW													// Para no utilizar el PIN RW comentar la siguiente definicin. 

#define DATA_PIN_7 	LATDbits.LATD7									// Para OUT usa "LATx".
#define DATA_PIN_6 	LATDbits.LATD6
#define DATA_PIN_5 	LATDbits.LATD5
#define DATA_PIN_4 	LATDbits.LATD4
	
#define READ_PIN_7	PORTDbits.RD7									// Para IN usa "PORTx".
#define READ_PIN_6	PORTDbits.RD6
#define READ_PIN_5	PORTDbits.RD5
#define READ_PIN_4	PORTDbits.RD4
		
#define TRIS_DATA_PIN_7	TRISDbits.TRISD7
#define TRIS_DATA_PIN_6	TRISDbits.TRISD6
#define TRIS_DATA_PIN_5	TRISDbits.TRISD5
#define TRIS_DATA_PIN_4	TRISDbits.TRISD4
	
	
#define 	E_PIN	LATEbits.LATE2 									// Para OUT usa "LATx".
#define 	RS_PIN	LATEbits.LATE1 
#ifdef USE_RW
	#define RW_PIN	LATBbits.LATB1 
#endif
	
#define 	TRIS_E	TRISEbits.TRISE2
#define 	TRIS_RS	TRISEbits.TRISE1 
#ifdef USE_RW 
	#define TRIS_RW	TRISBbits.TRISB1 
#endif 


#define lcd_type 2 													// lcd_type = xxxxxxNF. N = 1: 2 lines. F = 0: 5x7 dots.	
#define lcd_line_two 0x40 											// LCD RAM address for the 2nd line.

/*
//--- Modos de Entrada -------
 Incrementa Direccion, Display fijo		0x06
 Decrementa Direccion, Display fijo		0x04
 Incrementa Direccion, Cursor fijo		0x07
 Decrementa Direccion, Cursor fijo		0x05
//--- Corriemiento Cursor -----
 Cursor a la Izquierda					0x10
 Cursor a la Derecha					0x14
 Display a la Izquierda					0x18
 Display a la Derecha					0x1C
//--- Fijar Sistema ------------
 Bus 8 bits, 1 lnea, 5x7				0x30
 Bus 8 bits, 1 linea, 5x10				0x34
 Bus 8 bits, 2 lneas, 5x7				0x38
 Bus 4 bits, 1 lnea, 5x7				0x20	
 Bus 4 bits, 1 linea, 5x10				0x24
 Bus 4 bits, 2 lneas, 5x7 				0x28
*/

#endif